# Encoding extension

<!-- status autogenerated section -->
| Status        |           |
| ------------- |-----------|
| Stability     | [development]  |
| Distributions | [] |
| Issues        | [![Open issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aopen%20label%3Aextension%2Fencoding%20&label=open&color=orange&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aopen+is%3Aissue+label%3Aextension%2Fencoding) [![Closed issues](https://img.shields.io/github/issues-search/open-telemetry/opentelemetry-collector-contrib?query=is%3Aissue%20is%3Aclosed%20label%3Aextension%2Fencoding%20&label=closed&color=blue&logo=opentelemetry)](https://github.com/open-telemetry/opentelemetry-collector-contrib/issues?q=is%3Aclosed+is%3Aissue+label%3Aextension%2Fencoding) |
| [Code Owners](https://github.com/open-telemetry/opentelemetry-collector-contrib/blob/main/CONTRIBUTING.md#becoming-a-code-owner)    | [@MovieStoreGuy](https://www.github.com/MovieStoreGuy) |

[development]: https://github.com/open-telemetry/opentelemetry-collector#development
<!-- end autogenerated section -->

The encoding extension allows for other components to reference ingress/egress data formats 
to allow for simplified operability.

_🚧 Under active development 🚧_

## Component Milestones

To help track what work needs to be done with this component, these are the currently active goals being 
worked towards.

### Development

- CodecFactory: Allows other components to reference code by name and version
- Codec: Defining the expected interface for a codec
    - Length Delimited Codec: Used fixed length payloads to represent a collection of data that can be merged together
- Add existing formats to the codec's libraries.
- Add support to the following components
    - `file receiver`
    - `file exporter`
    - `kafka receiver`
    - `kafka exporter`
    - `kinesis exporter`
- Add codecs for open source formats, ie: `otlp`, `zipkin`, `jaeger`

Component support will be behind a feature gate to avoid change in behavior

### Alpha

- Adopt vendor formats as codecs 
- Transition feature gate to default to using encoding extension
- Add dynamic mapping support for `avro`, `parquet`, and `gotemplate`
    - Not fixed on these but I am aware that users are interested in these

### Beta

- Add support for remote schema management
    - Using `AWS Glue`, `kafka schema registry`
- Performance break down of difference codecs (static, dynamic, remote)
    - This is more to help provide information to users to expected performance impact.

### Stable

- All features complete
- Absent of bugs that impact core behaviours
- Dependencies can also be marked as stable

## Example configuration

```yaml
extensions:
  encoding:

receivers:
  kafka:
    encoding:
      name:   zipkin/v1
      format: proto
    # ... other configuration values
```

[translators]: https://github.com/open-telemetry/opentelemetry-collector-contrib/tree/main/pkg/translator